///////////////////////////////////////////////////////////////////
//Aufgabe 7 in Kapitel Räumliche Strukturen
//Lernziel: 3D-Körper zeichnen und bewegen
//Letzte Stufe: fünf Rotationen
//3D Pyramide, Zylinder, Säule
/////////////////////////////////////////////////////////////////
color[] farbeMantel= new color[8];//Zufallsfarben für max. 8-seitige Säule

//Fünf Winkel-Parameter. Zwei davon werden doppelt benutzt
float alpha  = 0;
float beta   = 0;
float gamma  = 0;
float delta   =0;
float epsilon =0;
int anzahlSeiten = 30;


void setup() {
  size(900, 900, P3D);  // oder size(900, 900, OPENGL);
  rectMode(CENTER);
   for(int i = 0; i<8;i++){
       farbeMantel[i] = color(random(255),random(255),random(255),200);  
    }  
}

public void draw() {
  background(0);
  stroke(0); lights();
  translate(width/2, height/2, 0);
  rotateY(delta);
  for (float i = 0; i < 2*PI; i +=PI/3 ) {
    pushMatrix(); 
    rotate(alpha + i);    
    rotateX(-i-beta);   
    pyramideZeichnen(8,400);  //Die Achsen des großen Sterns 
    fill(0,0,255,127);
    noStroke();  
    sphere(35);
    for (float j = 0; j < 2*PI; j += 2.0943951024) {
      pushMatrix();
      translate(300, 0, 0);
      rotateX(-j-beta);    
      rotateY(j+gamma);
      saeuleZeichnen(6,7,125); //Die in den magentafarbenen Kugeln steckende Prismen
      fill(255,0,255);
      noStroke();  
      sphere(19);
      for (float k = 0; k < 2*PI; k += PI) {
         pushMatrix();
         translate(0, 125, 0);
         rotateY(k+gamma);        
         fill(255,255,0);noStroke();  
         sphere(11);              
         fill(80, 130, 250);     
         rotateZ(k+epsilon); 
         saeuleZeichnen(60,4, 55 ); // Die in den gelben Kugeln steckende Säulen    
         translate(0,0,55);
         fill(0,255,255); 
         noStroke(); 
         sphere(8);       
         popMatrix();  
      }
      popMatrix();    
    } 
    popMatrix();
  }
 
 //Hiermit kann man die Drehfrequenzen bestimmen.
 //Ja größer, desto schneller die Drehung
  alpha   += 0.005;
  beta    += 0.02;
  gamma   += 0.06;
  delta   += 0.002;
  epsilon += 0.3;
}
//Bei allen 3D-Körpern wurden die Böden
//weggelassen, da sie verdeckt sind.

//8-seitige regelmäßige Pyramide als eigene 3D-Shape
void pyramideZeichnen(int s , int h) {
  stroke(0);strokeWeight(2);
  
  beginShape(TRIANGLES);
  fill(0, 255, 255, 150);
  vertex( 0, -s, -3*s);
  vertex( 0, s, -3*s);
  vertex( h, 0, 0);

  fill(0, 0, 255,150);
  vertex( 0, s, -3*s);
  vertex( 0, 3*s, -s);
  vertex( h, 0, 0);

  fill(200, 0, 240, 150);
  vertex( 0, 3*s, -s);
  vertex( 0, 3*s, s);
  vertex( 250, 0, 0);

  fill(0, 50, 230, 150);
  vertex( 0, 3*s, s);
  vertex( 0, s, 3*s);
  vertex( h, 0, 0);

  fill(255, 0, 255, 150);
  vertex( 0, s, 3*s);
  vertex( 0, -s, 3*s);
  vertex( h, 0, 0);

  fill(255, 25, 200, 150);
  vertex( 0, -s, 3*s);
  vertex( 0, -3*s, s);
  vertex( h, 0, 0);

  fill(255, 0, 255, 150);
  vertex( 0, -3*s, s);
  vertex( 0, -3*s, -s);
  vertex( h, 0, 0);

  fill(0, 255, 255, 150);
  vertex( 0, -3*s, -s);
  vertex( 0, -s, -3*s);
  vertex( h, 0, 0);

  endShape(); 
}

//Bei einer Seitenzahl von 30-60 bekommt man eine Näherung für einen Zylinder
void saeuleZeichnen( int sides, float r, float h){
  float angle = 360 / sides;
     
  beginShape(QUAD);
    float rot = 0; 
    float blau = 0;
    for (int i = 0; i < sides ; i++) {
        float x1 = cos( radians( i * angle ) ) * r;
        float y1 = sin( radians( i * angle ) ) * r;
        float x2 = cos( radians( (i+1) * angle ) ) * r;
        float y2 = sin( radians( (i+1) * angle ) ) * r;
      //Farbverlauf rot-blau-rot
      if(sides>8){
         // if(i*angle <= 180){
            rot = map(i*angle,0,360,255,0);//abnehmend rot
            blau= map(i*angle,0,360,0,255);//zunehmend blau
        //  }
        //  if(i*angle > 180 && angle<=360){
        //    blau = map(i*angle,360,180,0,255);
        //    rot  = map(i*angle,180,360,0,255);
         // }
          noStroke();fill(rot,0,blau);
          vertex( x1,y1,0);
          vertex( x1,y1,h); 
          vertex( x2,y2,h);
          vertex( x2,y2,0);       
        }else{
          if(i<sides){
            fill(farbeMantel[i],200);
            
        vertex( x1, 0, y1);
        vertex( x1, h, y1); 
        vertex( x2, h, y2);
        vertex( x2, 0, y2);         
          }       
        }
    endShape(CLOSE);
    }
}  